︠384986ed-0541-48a1-b9a6-9269f1c5519d︠
def DFS_Visit(g, i, color):
    # print for strongly connected components
    print " " + str(i)
    # color vertex red
    color[i] = 1;
    for j in g.neighbors_out(i):
        if color[j] == 0:
            color = DFS_Visit(g, j, color)
    # we are finished visiting this vertex
    #print "vertex " + str(i) + " is colored blue."
    color[i] = 2
    return color
# end def DFS_Visit


def DFS_finish(g, i, cur_time, fin, color):
    #print "vertex " + str(i) + " start time = " + str(cur_time)
    # color vertex red
    #print "vertex " + str(i) + " is colored red."
    color[i] = 1;
    for j in g.neighbors_out(i):
        if color[j] == 0:
            # increment the cur_time to the next time step
            (cur_time, fin, color) = DFS_finish(g, j, cur_time + 1, fin, color)
    
    # we are finished visiting this vertex
    #print "vertex " + str(i) + " is colored blue."
    color[i] = 2
    #print "vertex " + str(i) + " finish time = " + str(cur_time)
    fin[i] = cur_time;
    # return the data structures
    return (cur_time + 1, fin, color)
#end def DFS_finish

# generate a random directed graph
n = 20; p = .1
g = digraphs.RandomDirectedGNP(n, p, false);
g.show()

# show the strongly connected components using built-in functions
for scc in g.strongly_connected_components_subgraphs():
    scc.show()

# initialize all variables having to do with implementation
# of StronglyConnectedComponents
# initialize all beginning variables
color = [0]*n
fin = [0]*n
cur_time = 0

# main loop of the depth first search to calculate finishing times
for i in range(0, n):
    if color[i] == 0:
        (cur_time, fin, color) = DFS_finish(g, i, cur_time, fin, color)

# get the indices of the sorted list
s_fin = [i[0] for i in sorted(enumerate(fin), key=lambda x:x[1])]

# reverse the graph
g_rev = g.reverse();
# reinitialize the color array to restart your DFS
color = [0]*n
# iterate over the list in reverse
for i in range(n-1,-1,-1):
    if color[s_fin[i]] == 0:
        print "strongly connected component:"
        color = DFS_Visit(g_rev, s_fin[i], color)

# helper code to help sort lists
# myList = [1, 2, 3, 100, 5]
# L = [i[0] for i in sorted(enumerate(myList), key=lambda x:x[1])]
# L
#for i in range(4,-1,-1):  iterate the list in reverse
#     myList[L[i]]

︡328be496-f9e2-4c07-b749-092fff31a5d7︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/220/tmp_2tgTbS.svg","show":true,"text":null,"uuid":"c78196c6-4c66-4aea-8ec6-5e7edaa2d7e9"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/220/tmp_USo6Z7.svg","show":true,"text":null,"uuid":"90015729-d82d-4d53-a950-13fc91a25032"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/220/tmp_FWyU6Q.svg","show":true,"text":null,"uuid":"e1de05c6-ee79-4023-8497-4c7d7f85613c"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/220/tmp_9oRov7.svg","show":true,"text":null,"uuid":"0f643adb-862c-4924-94e3-389cef133aaa"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/220/tmp_YqrpCk.svg","show":true,"text":null,"uuid":"c1b62849-7ac4-4877-8da2-deff287a0ded"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/220/tmp_LPGBBP.svg","show":true,"text":null,"uuid":"dd0584a4-dc27-49a2-9132-bf4dfffc2d85"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/220/tmp_wgIhA_.svg","show":true,"text":null,"uuid":"8dbf22b4-21be-49db-a898-7077223d3179"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/220/tmp_FJrRuB.svg","show":true,"text":null,"uuid":"d1ae5e18-280d-4d0e-8587-6ea43c856302"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-312b5dfd-a6ad-48f3-830b-d35eb199d477/220/tmp_gmzLh7.svg","show":true,"text":null,"uuid":"aa9bbd03-3a7b-45b0-a670-09e35a8cac3c"},"once":false}︡{"stdout":"strongly connected component:\n 16\nstrongly connected component:\n 18\nstrongly connected component:\n 14\nstrongly connected component:\n 13\nstrongly connected component:\n 19\nstrongly connected component:\n 7\nstrongly connected component:\n 0\n 8\n 9\n 15\n 10\n 2\n 1\n 4\n 17\n 5\n 11\n 3\n 6\nstrongly connected component:\n 12\n"}︡{"done":true}︡
︠44cb4183-2d95-4956-be21-b725d989ea6b︠









